import java.lang.Runnable;
import java.lang.Thread;
import java.lang.ThreadGroup;

public class BoundedBufferTest
{
    private BoundedBuffer buffer = new BoundedBuffer();

    class Producer
	implements Runnable
    {
	public void run()
	{
	    int i = 0;
	    
	    while (true) {
		buffer.insert(i++);
	    }
	}
    }
    
    class Consumer
	implements Runnable
    {
	public void run()
	{
	    while (true) {
		int val = buffer.remove();
		System.out.println(val);
	    }
	}
    }
    
    public static void main(String[] args)
    {
	BoundedBufferTest test = new BoundedBufferTest();

	ThreadGroup producer = new ThreadGroup("producer");
	ThreadGroup consumer = new ThreadGroup("consumer");

	for (int i = 0; i < 5; i++) {
	    Thread t = new Thread(producer, test.new Producer());
	    t.start();
	}

    	for (int i = 0; i < 2; i++) {
	    Thread t = new Thread(consumer, test.new Consumer());
	    t.start();
	}
    }
}
